## linglong-box 1.3.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(linglong-box)

# 保证项目兼容性
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(VERSION "1.0")

option(BUILD_STATIC "Build the static binary" ON)

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
  if (NOT CMAKE_DEBUG_ASAN)
    set(CMAKE_CXX_FLAGS_DEBUG "-O0  -Wall -g -ggdb3")
  else ()
    set(CMAKE_CXX_FLAGS_DEBUG "-O0 -fsanitize=undefined,address -Wall -g -ggdb3")
    set(BUILD_STATIC OFF)
  endif ()
endif ()

include(GNUInstallDirs)
include_directories(${linglong-box_SOURCE_DIR})
include_directories(${linglong-box_SOURCE_DIR}/src)


find_package(PkgConfig)

add_subdirectory(src)

add_subdirectory(test)

=== src/CMakeLists.txt ===
pkg_check_modules(SECCOMP REQUIRED libseccomp)

set(LINK_LIBS
    seccomp
    stdc++)

set(LL_BOX_SOURCES
    # cmake-format: sortable
    main.cpp
    loader.cpp
    util/common.cpp
    util/filesystem.cpp
    util/semaphore.cpp
    util/debug/debug.cpp
    util/platform.cpp
    util/logger.cpp
    util/message_reader.cpp
    container/container.cpp
    container/mount/host_mount.cpp
    container/mount/filesystem_driver.cpp
    container/seccomp.cpp
    )
add_executable(ll-box ${LL_BOX_SOURCES})
target_link_libraries(ll-box ${LINK_LIBS})

if (BUILD_STATIC)
  add_executable(ll-box-static ${LL_BOX_SOURCES})
  target_link_libraries(ll-box-static -static ${LINK_LIBS})
  install(TARGETS ll-box-static RUNTIME DESTINATION ${CMAKE_INSTALL_PREFIX}/libexec)
endif (BUILD_STATIC)

install(TARGETS ll-box RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
#install(TARGETS ll-box RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
#        PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE SETUID)

=== test/CMakeLists.txt ===
enable_testing()

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} --coverage")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage")

find_package(GTest REQUIRED)
find_package(PkgConfig)

pkg_check_modules(SECCOMP REQUIRED libseccomp)

set(LINK_LIBS
    yaml-cpp
    GTest::GTest gtest_main
    seccomp
    stdc++)

add_executable(ll-test
               oci_test.cpp
               seccomp_test.cpp
               ../src/util/logger.cpp
               ../src/container/seccomp.cpp)

target_link_libraries(ll-test ${LINK_LIBS})

add_test(NAME ll_test COMMAND ll-test)

=== test/protype/CMakeLists.txt ===
set(LINK_LIBS
    stdc++)

add_executable(ll-wrapper
               main.cpp
               ../../src/util/semaphore.cpp
               ../../src/util/filesystem.cpp
               ../../src/util/common.cpp)

target_link_libraries(ll-wrapper ${LINK_LIBS})

install(TARGETS ll-wrapper RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)

=== debian/changelog ===
linglong-box (1.3.4-1) unstable; urgency=medium

  * update version;
  * fix some bugs.

 -- Chen Linxuan <me@black-desk.cn>  Wed, 03 Jan 2024 17:06:55 +0800

linglong-box (1.3.3.15-1) unstable; urgency=medium

  * update version.

 -- huqinghong <huqinghong@uniontech.com>  Tue, 27 Dec 2022 14:54:52 +0800

linglong-box (1.3.3.14-1) unstable; urgency=medium

  * update version.

 -- yuanqiliang <yuanqiliang@uniontech.com>  Thu, 25 Nov 2022 11:02:00 +0800

linglong-box (1.3.3.13-1) unstable; urgency=medium

  * update version.

 -- Chen Linxuan <chenlinxuan@uniontech.com>  Thu, 24 Nov 2022 11:02:00 +0800

linglong-box (1.3.3.12-1) unstable; urgency=medium

  * update version.

 -- Chen Linxuan <chenlinxuan@uniontech.com>  Thu, 27 Oct 2022 14:58:00 +0800

linglong-box (1.3.3.11-1) unstable; urgency=medium

  * update version to 1.3.3.11-1 for deepin.

 -- huqinghong <huqinghong@uniontech.com>  Wed, 26 Oct 2022 15:33:06 +0800

linglong-box (1.3.3.10-1) unstable; urgency=medium

  * update version.

 -- chenhuixing <chenhuixing@uniontech.com>  Fri, 23 Sep 2022 11:19:11 +0800

linglong-box (1.3.3.9-1) unstable; urgency=medium

  * update version.

 -- chenlinxuan <chenlinxuan@uniontech.com>  Thu, 22 Sep 2022 11:09:15 +0800

linglong-box (1.3.3.7-1) unstable; urgency=medium

  * update version.

 -- chenhuixing <chenhuixing@uniontech.com>  Tue, 06 Sep 2022 10:58:15 +0800

linglong-box (1.3.3.5-1) unstable; urgency=medium

  * update version to 1.3.3.5-1 for deepin.

 -- liujianqiang <liujianqiang@uniontech.com>  Mon, 01 Aug 2022 20:50:57 +0800

linglong-box (1.3.3-1) unstable; urgency=medium

  * update version to 1.3.3-1 for deepin.

 -- liujianqiang <liujianqiang@uniontech.com>  Thu, 28 Jul 2022 15:29:46 +0800

linglong-box (1.3.2-1) unstable; urgency=medium

  * update version.

 -- liujianqiang <liujianqiang@uniontech.com>  Fri, 24 Jun 2022 16:56:42 +0800

linglong-box (1.3.0-1) unstable; urgency=medium

  * update version.

 -- liujianqiang <liujianqiang@uniontech.com>  Fri, 27 May 2022 17:45:46 +0800

linglong-box (1.2.7-1) unstable; urgency=medium

  * fix build issue.

 -- liujianqiang <liujianqiang@uniontech.com>  Fri, 15 Apr 2022 18:33:27 +0800

linglong-box (1.2.6-1) unstable; urgency=medium

  * 1. adjust wait pid strategy.
  * 2. print pidns in log.
  * 3. configure uid/gid mapping after clone.
  * 4. remove CLONE-FS flag when cloning NonePrivilegeProc.
  * 5. wrong /dev/ptmx link.

 -- liujianqiang <liujianqiang@uniontech.com>  Tue, 22 Mar 2022 13:38:53 +0800

linglong-box (1.2.5-1) unstable; urgency=medium

  * 1. rename json fields.
  * 2. close leaked fds.
  * 3. remove forced CLONE_NEWPID flag for second clone.
  * 4. add waitpid helper.
  * 5. add support for dbus proxy.
  * 6. remove unused code.

 -- liujianqiang <liujianqiang@uniontech.com>  Tue, 15 Mar 2022 10:04:16 +0800

linglong-box (1.2.4-1) unstable; urgency=medium

  * 1. void c_str() of destoryed string

 -- chenlinxuan <chenlinxuan@uniontech.com>  Tue, 08 Mar 2022 13:27:24 +0800

linglong-box (1.2.3-1) unstable; urgency=medium

  * 1. make fuse-overlayfs defalut.
  * 2. fix update error info.
  * 3. fix do mount by proc fd.

 -- liujianqiang <liujianqiang@uniontech.com>  Tue, 08 Mar 2022 13:27:24 +0800

linglong-box (1.2.2-1) unstable; urgency=medium

  * 1. fix read/write /dev/null failed.
  * 2. add log fliter.
  * 3. fix mount mqueue amd cgroup in rootless mode.
  * 4. fix make mountnode const again.
  * 5. fix make ro bind work.

 -- liujianqiang <liujianqiang@uniontech.com>  Wed, 16 Feb 2022 13:47:58 +0800

linglong-box (1.2.1-1) unstable; urgency=medium

  *  1. fuse proxy support
  *  2. fix construct string with nullptr cause crash
  *  3. fallback to bind when sysfs mount failed
  *  4. root mount for ll-fuse-proxy

 -- liujianqiang <liujianqiang@uniontech.com>  Mon, 24 Jan 2022 08:55:58 +0800

linglong-box (1.2.0-1) unstable; urgency=medium

  *  mount add a MS_REC flag

 -- liujianqiang <liujianqiang@uniontech.com>  Fri, 14 Jan 2022 10:51:13 +0800

linglong-box (1.0.1-1) unstable; urgency=medium

  * support rootless and fuse

 -- iceyer <me@iceyer.net>  Wed, 29 Dec 2021 17:57:01 +0800

linglong-box (1.0-1) unstable; urgency=medium

  * Init package.

 -- chenhuixing <chenhuixing@uniontech.com>  Thu, 09 Sep 2021 11:41:48 +0000

=== debian/control ===
Source: linglong-box
Section: admin
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.org>
Build-Depends:
 debhelper (>= 11),
 cmake,
 libyaml-cpp-dev,
 pkg-config,
 libseccomp-dev,
 libgtest-dev
Standards-Version: 4.1.3
Homepage: https://www.deepin.org

Package: linglong-box
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Deepin sandbox with OCI standard.
 Deepin sandbox...

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/default.mk
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	  -DCMAKE_BUILD_TYPE=Release \
	  -DCMAKE_INSTALL_PREFIX=/usr \
      -DAPP_VERSION=$(DEB_VERSION_UPSTREAM) -DVERSION=$(DEB_VERSION_UPSTREAM) LIB_INSTALL_DIR=/usr/lib DH_AUTO_ARGS

## linglong-box 2.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.11.4) # for RHEL 8

project(
  linyaps-box
  VERSION 2.0.0
  DESCRIPTION "A simple OCI runtime for desktop applications"
  HOMEPAGE_URL "https://github.com/OpenAtom-Linyaps/linyaps-box"
  LANGUAGES CXX)

# ==============================================================================
# Utilities
# ==============================================================================

# NOTE: Modified from https://www.scivision.dev/cmake-project-is-top-level/
if(CMAKE_VERSION VERSION_LESS 3.21)
  get_property(
    not_top
    DIRECTORY
    PROPERTY PARENT_DIRECTORY)
  if(NOT not_top)
    set(linyaps-box_IS_TOP_LEVEL true)
  else()
    set(linyaps-box_IS_TOP_LEVEL false)
  endif()
endif()

# ==============================================================================
# Build options
# ==============================================================================

option(linyaps-box_STATIC "Build linyaps-box as statically-linked binary." OFF)

option(linyaps-box_ENABLE_SECCOMP "Build linyaps-box with seccomp support." OFF)

option(linyaps-box_ENABLE_CAP "Build linyaps-box with capability support" ON)

option(linyaps-box_ENABLE_UNIT_TESTS "Enable unit tests."
       ${linyaps-box_IS_TOP_LEVEL})

option(linyaps-box_ENABLE_SMOKE_TESTS "Enable smoke tests." OFF)

if(linyaps-box_ENABLE_SMOKE_TESTS OR linyaps-box_ENABLE_UNIT_TESTS)
  set(linyaps-box_ENABLE_TESTING ON)
endif()

option(linyaps-box_ENABLE_COVERAGE "Enable coverage." OFF)

if(linyaps-box_ENABLE_COVERAGE AND NOT linyaps-box_ENABLE_TESTING)
  message(
    FATAL_ERROR
      "linyaps-box_ENABLE_COVERAGE requires linyaps-box_ENABLE_UNIT_TESTS or linyaps-box_ENABLE_SMOKE_TESTS."
  )
endif()

option(linyaps-box_ENABLE_CPACK "Enable CPack." OFF)

if(linyaps-box_ENABLE_CPACK)
  set(linyaps-box_CPACK_PACKAGING_INSTALL_PREFIX
      "/opt/org.openatom.linyaps-box"
      CACHE STRING "Install prefix for package generated by CPack.")
endif()

set(linyaps-box_CLONE_CHILD_STACK_SIZE
    "(1U << 20)"
    CACHE
      STRING
      "DO NOT MODIFY THIS SETTINGS UNLESS YOU KNOW WHAT YOU ARE DOING. Size of child stack in bytes when using clone(2) to create container."
)

set(linyaps-box_STACK_GROWTH_DOWN
    true
    CACHE
      BOOL
      "DO NOT MODIFY THIS SETTINGS UNLESS YOU KNOW WHAT YOU ARE DOING. If stacks grow upward on your processor, set this to false."
)

set(linyaps-box_DEFAULT_LOG_LEVEL
    LOG_WARNING
    CACHE
      STRING
      "The default syslog priority. This is used to filter log messages at runtime time."
)

set(linyaps-box_ACTIVE_LOG_LEVEL
    LOG_WARNING
    CACHE
      STRING
      "The active syslog priority. This is used to filter log messages at compile time."
)

set(linyaps-box_ENABLE_CPM
    ON
    CACHE BOOL "enable CPM")

if(CMAKE_VERSION VERSION_LESS "3.14")
  set(linyaps-box_ENABLE_CPM OFF)
  message(
    STATUS "cmake version ${CMAKE_VERSION} not compatible with CPM.cmake.")
endif()

# if just want to try local packages at first set CPM_USE_LOCAL_PACKAGES ON
set(linyaps-box_CPM_LOCAL_PACKAGES_ONLY
    OFF
    CACHE BOOL "use local packages only")

if(linyaps-box_CPM_LOCAL_PACKAGES_ONLY)
  message(STATUS "CPM is disabled")
  set(linyaps-box_ENABLE_CPM OFF)
endif()

# ==============================================================================

set(linyaps-box_LIBRARY linyaps-box)
set(linyaps-box_LIBRARY_SOURCE
    # find -regex '\./src/.+\.[ch]\(pp\)?' -type f -printf '%P\n'| sort
    src/linyaps_box/app.cpp
    src/linyaps_box/app.h
    src/linyaps_box/cgroup.h
    src/linyaps_box/cgroup_manager.c
    src/linyaps_box/cgroup_manager.h
    src/linyaps_box/command/exec.cpp
    src/linyaps_box/command/exec.h
    src/linyaps_box/command/kill.cpp
    src/linyaps_box/command/kill.h
    src/linyaps_box/command/list.cpp
    src/linyaps_box/command/list.h
    src/linyaps_box/command/options.cpp
    src/linyaps_box/command/options.h
    src/linyaps_box/command/run.cpp
    src/linyaps_box/command/run.h
    src/linyaps_box/config.cpp
    src/linyaps_box/config.h
    src/linyaps_box/container.cpp
    src/linyaps_box/container.h
    src/linyaps_box/container_ref.cpp
    src/linyaps_box/container_ref.h
    src/linyaps_box/container_status.cpp
    src/linyaps_box/container_status.h
    src/linyaps_box/impl/disabled_cgroup_manager.cpp
    src/linyaps_box/impl/disabled_cgroup_manager.h
    src/linyaps_box/impl/json_printer.cpp
    src/linyaps_box/impl/json_printer.h
    src/linyaps_box/impl/status_directory.cpp
    src/linyaps_box/impl/status_directory.h
    src/linyaps_box/impl/table_printer.cpp
    src/linyaps_box/impl/table_printer.h
    src/linyaps_box/interface.cpp
    src/linyaps_box/interface.h
    src/linyaps_box/printer.cpp
    src/linyaps_box/printer.h
    src/linyaps_box/runtime.cpp
    src/linyaps_box/runtime.h
    src/linyaps_box/status_directory.cpp
    src/linyaps_box/status_directory.h
    src/linyaps_box/utils/atomic_write.cpp
    src/linyaps_box/utils/atomic_write.h
    src/linyaps_box/utils/cgroups.cpp
    src/linyaps_box/utils/cgroups.h
    src/linyaps_box/utils/close_range.cpp
    src/linyaps_box/utils/close_range.h
    src/linyaps_box/utils/defer.h
    src/linyaps_box/utils/file_describer.cpp
    src/linyaps_box/utils/file_describer.h
    src/linyaps_box/utils/fstat.cpp
    src/linyaps_box/utils/fstat.h
    src/linyaps_box/utils/inspect.cpp
    src/linyaps_box/utils/inspect.h
    src/linyaps_box/utils/log.cpp
    src/linyaps_box/utils/log.h
    src/linyaps_box/utils/mkdir.cpp
    src/linyaps_box/utils/mkdir.h
    src/linyaps_box/utils/mknod.cpp
    src/linyaps_box/utils/mknod.h
    src/linyaps_box/utils/open_file.cpp
    src/linyaps_box/utils/open_file.h
    src/linyaps_box/utils/platform.cpp
    src/linyaps_box/utils/platform.h
    src/linyaps_box/utils/semver.cpp
    src/linyaps_box/utils/semver.h
    src/linyaps_box/utils/socketpair.cpp
    src/linyaps_box/utils/socketpair.h
    src/linyaps_box/utils/touch.cpp
    src/linyaps_box/utils/touch.h)

set(LINYAPS_BOX_VERSION ${PROJECT_VERSION})
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/linyaps_box/version.h.in
               ${CMAKE_CURRENT_BINARY_DIR}/src/linyaps_box/version.h @ONLY)

# for gcc 8
set(linyaps-box_LIBRARY_LINK_LIBRARIES "stdc++fs")
set(linyaps-box_LIBRARY_INCLUDE_DIRS PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/src"
                                     "${CMAKE_CURRENT_BINARY_DIR}/src")

if(linyaps-box_STATIC)
  set(CMAKE_FIND_LIBRARY_SUFFIXES ".a")
endif()

find_package(PkgConfig REQUIRED)

if(linyaps-box_ENABLE_SECCOMP)
  pkg_check_modules(libseccomp REQUIRED IMPORTED_TARGET libseccomp>=2.3.3)
  list(APPEND linyaps-box_LIBRARY_LINK_LIBRARIES PUBLIC PkgConfig::libseccomp)
endif()

if(linyaps-box_ENABLE_CAP)
  pkg_check_modules(libcap REQUIRED IMPORTED_TARGET libcap>=2.25)
  list(APPEND linyaps-box_LIBRARY_LINK_LIBRARIES PUBLIC PkgConfig::libcap)
endif()

if(linyaps-box_ENABLE_CPM)
  list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
  include(CPM)

  CPMFindPackage(
    NAME nlohmann_json
    VERSION 3.11.3
    GITHUB_REPOSITORY nlohmann/json
    GIT_TAG v3.12.0
    EXCLUDE_FROM_ALL ON
    OPTIONS "JSON_BuildTests OFF")
  CPMFindPackage(
    NAME CLI11
    VERSION 2.4.1
    GITHUB_REPOSITORY CLIUtils/CLI11
    GIT_TAG v2.4.1
    EXCLUDE_FROM_ALL ON
    OPTIONS "CLI11_BUILD_TESTS OFF")
endif()

find_package(nlohmann_json 3.11.3 QUIET)
if(NOT nlohmann_json_FOUND)
  add_subdirectory(external/nlohmann_json)
  list(APPEND CMAKE_MODULE_PATH
       "${CMAKE_CURRENT_SOURCE_DIR}/cmake.external/nlohmann_json")
  find_package(nlohmann_json 3.11.3 REQUIRED)
  message(STATUS "use vendor nlohmann_json ${nlohmann_json_VERSION}")
endif()

list(APPEND linyaps-box_LIBRARY_LINK_LIBRARIES PUBLIC
     nlohmann_json::nlohmann_json)

find_package(CLI11 2.4.1 QUIET)
if(NOT CLI11_FOUND)
  add_subdirectory(external/CLI11)
  list(APPEND CMAKE_MODULE_PATH
       "${CMAKE_CURRENT_SOURCE_DIR}/cmake.external/CLI11")
  find_package(CLI11 2.4.1 REQUIRED)
  message(STATUS "use vendor CLI11 ${CLI11_VERSION}")
endif()

list(APPEND linyaps-box_LIBRARY_LINK_LIBRARIES PUBLIC CLI11::CLI11)

add_library("${linyaps-box_LIBRARY}" ${linyaps-box_LIBRARY_SOURCE})
target_include_directories("${linyaps-box_LIBRARY}"
                           ${linyaps-box_LIBRARY_INCLUDE_DIRS})
target_link_libraries("${linyaps-box_LIBRARY}"
                      PRIVATE ${linyaps-box_LIBRARY_LINK_LIBRARIES})
target_compile_features("${linyaps-box_LIBRARY}" PUBLIC cxx_std_17)
set_property(TARGET "${linyaps-box_LIBRARY}" PROPERTY CXX_STANDARD 17)
set_property(TARGET "${linyaps-box_LIBRARY}" PROPERTY CXX_EXTENSIONS OFF)
set_property(TARGET "${linyaps-box_LIBRARY}" PROPERTY CXX_STANDARD_REQUIRED ON)

include(CheckIncludeFileCXX)
check_include_file_cxx("linux/openat2.h" LINYAPS_BOX_HAVE_OPENAT2_H)

if(${LINYAPS_BOX_HAVE_OPENAT2_H})
  target_compile_definitions("${linyaps-box_LIBRARY}"
                             PRIVATE "LINYAPS_BOX_HAVE_OPENAT2_H")
endif()

target_compile_definitions(
  "${linyaps-box_LIBRARY}"
  PRIVATE
    "LINYAPS_BOX_CLONE_CHILD_STACK_SIZE=${linyaps-box_CLONE_CHILD_STACK_SIZE}"
  PRIVATE "LINYAPS_BOX_STACK_GROWTH_DOWN=${linyaps-box_STACK_GROWTH_DOWN}"
  PRIVATE "LINYAPS_BOX_DEFAULT_LOG_LEVEL=${linyaps-box_DEFAULT_LOG_LEVEL}"
  PRIVATE "LINYAPS_BOX_ACTIVE_LOG_LEVEL=${linyaps-box_ACTIVE_LOG_LEVEL}")
target_compile_options("${linyaps-box_LIBRARY}"
                       PRIVATE -fmacro-prefix-map=${CMAKE_CURRENT_SOURCE_DIR}=.)
if(linyaps-box_STATIC)
  target_compile_definitions("${linyaps-box_LIBRARY}"
                             PUBLIC "LINYAPS_BOX_STATIC_LINK")
endif()

if(linyaps-box_ENABLE_SECCOMP)
  target_compile_definitions("${linyaps-box_LIBRARY}"
                             PUBLIC LINYAPS_BOX_ENABLE_SECCOMP)
endif()

if(linyaps-box_ENABLE_CAP)
  target_compile_definitions("${linyaps-box_LIBRARY}"
                             PUBLIC LINYAPS_BOX_ENABLE_CAP)
endif()

if(linyaps-box_ENABLE_COVERAGE)
  if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    target_compile_options("${linyaps-box_LIBRARY}"
                           PRIVATE -fprofile-instr-generate -fcoverage-mapping)
    target_link_options("${linyaps-box_LIBRARY}" PUBLIC
                        -fprofile-instr-generate -fcoverage-mapping)
  elseif(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    target_compile_options("${linyaps-box_LIBRARY}" PRIVATE --coverage)
    target_link_options("${linyaps-box_LIBRARY}" PUBLIC --coverage)
  else()
    message(
      FATAL_ERROR "Coverage is not supported for ${CMAKE_CXX_COMPILER_ID}.")
  endif()
endif()

# ==============================================================================

set(linyaps-box_APP ll-box)
set(linyaps-box_APP_SOURCE "./app/${linyaps-box_APP}/src/main.cpp")
set(linyaps-box_APP_LINK_LIBRARIES PRIVATE "${linyaps-box_LIBRARY}")
set(linyaps-box_APP_SOURCE_INCLUDE_DIRS
    PRIVATE "${CMAKE_CURRENT_SOURCE_DIR}/app/${linyaps-box_APP}/src")

add_executable("${linyaps-box_APP}" ${linyaps-box_APP_SOURCE})
target_include_directories("${linyaps-box_APP}"
                           ${linyaps-box_APP_SOURCE_INCLUDE_DIRS})
target_link_libraries("${linyaps-box_APP}" ${linyaps-box_APP_LINK_LIBRARIES})
if(linyaps-box_STATIC)
  target_link_options("${linyaps-box_APP}" PRIVATE -static -static-libgcc
                      -static-libstdc++)
endif()
target_compile_features("${linyaps-box_APP}" PRIVATE cxx_std_17)
set_property(TARGET "${linyaps-box_APP}" PROPERTY CXX_STANDARD 17)
set_property(TARGET "${linyaps-box_APP}" PROPERTY CXX_EXTENSIONS OFF)
set_property(TARGET "${linyaps-box_APP}" PROPERTY CXX_STANDARD_REQUIRED ON)
target_compile_definitions(
  "${linyaps-box_APP}"
  PRIVATE "LINYAPS_BOX_DEFAULT_LOG_LEVEL=${linyaps-box_DEFAULT_LOG_LEVEL}"
  PRIVATE "LINYAPS_BOX_ACTIVE_LOG_LEVEL=${linyaps-box_AVTIVE_LOG_LEVEL}")
target_compile_options("${linyaps-box_APP}"
                       PRIVATE -fmacro-prefix-map=${CMAKE_CURRENT_SOURCE_DIR}=.)

# ==============================================================================

include(GNUInstallDirs)

=== external/CLI11/CMakeLists.txt ===
add_library(CLI11 INTERFACE)
add_library(CLI11::CLI11 ALIAS CLI11)
target_include_directories(CLI11 INTERFACE "${CMAKE_CURRENT_SOURCE_DIR}/include/")

=== debian/changelog ===
linglong-box (2.0.0-1) unstable; urgency=medium

  * release 1.8.1-1.

 -- dengbo <dengbo@deepin.org>  Thu, 10 Apr 2025 13:45:47 +0800

## linglong-box 2.0.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 project(
   linyaps-box
-  VERSION 2.0.0
+  VERSION 2.0.3
   DESCRIPTION "A simple OCI runtime for desktop applications"
   HOMEPAGE_URL "https://github.com/OpenAtom-Linyaps/linyaps-box"
   LANGUAGES CXX)
@@ -38,6 +38,8 @@
        ${linyaps-box_IS_TOP_LEVEL})
 
 option(linyaps-box_ENABLE_SMOKE_TESTS "Enable smoke tests." OFF)
+
+option(linyaps-box_MAKE_RELEASE "Make release build." OFF)
 
 if(linyaps-box_ENABLE_SMOKE_TESTS OR linyaps-box_ENABLE_UNIT_TESTS)
   set(linyaps-box_ENABLE_TESTING ON)
@@ -179,10 +181,26 @@
     src/linyaps_box/utils/semver.h
     src/linyaps_box/utils/socketpair.cpp
     src/linyaps_box/utils/socketpair.h
+    src/linyaps_box/utils/symlink.cpp
+    src/linyaps_box/utils/symlink.h
     src/linyaps_box/utils/touch.cpp
     src/linyaps_box/utils/touch.h)
 
 set(LINYAPS_BOX_VERSION ${PROJECT_VERSION})
+
+if(NOT linyaps-box_MAKE_RELEASE)
+  message(STATUS "make dev build")
+
+  execute_process(
+    COMMAND git rev-parse --short=7 HEAD
+    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
+    OUTPUT_VARIABLE GIT_COMMIT_HASH
+    OUTPUT_STRIP_TRAILING_WHITESPACE
+  )
+
+  set(LINYAPS_BOX_VERSION "${LINYAPS_BOX_VERSION}-dev-${GIT_COMMIT_HASH}")
+endif()
+
 configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/linyaps_box/version.h.in
                ${CMAKE_CURRENT_BINARY_DIR}/src/linyaps_box/version.h @ONLY)
 
@@ -222,7 +240,7 @@
     NAME CLI11
     VERSION 2.4.1
     GITHUB_REPOSITORY CLIUtils/CLI11
-    GIT_TAG v2.4.1
+    GIT_TAG v2.5.0
     EXCLUDE_FROM_ALL ON
     OPTIONS "CLI11_BUILD_TESTS OFF")
 endif()
@@ -326,15 +344,3 @@
 target_compile_features("${linyaps-box_APP}" PRIVATE cxx_std_17)
 set_property(TARGET "${linyaps-box_APP}" PROPERTY CXX_STANDARD 17)
 set_property(TARGET "${linyaps-box_APP}" PROPERTY CXX_EXTENSIONS OFF)
-set_property(TARGET "${linyaps-box_APP}" PROPERTY CXX_STANDARD_REQUIRED ON)
-target_compile_definitions(
-  "${linyaps-box_APP}"
-  PRIVATE "LINYAPS_BOX_DEFAULT_LOG_LEVEL=${linyaps-box_DEFAULT_LOG_LEVEL}"
-  PRIVATE "LINYAPS_BOX_ACTIVE_LOG_LEVEL=${linyaps-box_AVTIVE_LOG_LEVEL}")
-target_compile_options("${linyaps-box_APP}"
-                       PRIVATE -fmacro-prefix-map=${CMAKE_CURRENT_SOURCE_DIR}=.)
-
-# ==============================================================================
-
-include(GNUInstallDirs)
-

=== external/nlohmann_json/CMakeLists.txt ===
# https://github.com/nlohmann/json/tree/v3.11.3?tab=readme-ov-file#integration

add_library(nlohmann_json INTERFACE)
add_library(nlohmann_json::nlohmann_json ALIAS nlohmann_json)
target_include_directories(nlohmann_json INTERFACE "${CMAKE_CURRENT_SOURCE_DIR}/include/")

=== debian/changelog ===
linglong-box (2.0.3-1) unstable; urgency=medium

  * release 2.0.3-1.

 -- dengbo <dengbo@deepin.org>  Thu, 17 Jul 2025 21:57:45 +0800

linglong-box (2.0.2-1) unstable; urgency=medium

  * release 2.0.2-1.

 -- dengbo <dengbo@deepin.org>  Wed, 16 Jul 2025 15:21:14 +0800

linglong-box (1.8.1-1) unstable; urgency=medium

  * release 1.8.1-1.

 -- dengbo <dengbo@deepin.org>  Thu, 10 Apr 2025 13:45:47 +0800

=== debian/control ===
--- 
+++ 
@@ -5,10 +5,12 @@
 Build-Depends:
  debhelper (>= 11),
  cmake,
- libyaml-cpp-dev,
+ libcli11-dev (>= 2.4.1) | hello,
  pkg-config,
  libseccomp-dev,
- libgtest-dev
+ nlohmann-json3-dev (>= 3.5.0) | hello,
+ libgtest-dev,
+ libcap-dev
 Standards-Version: 4.1.3
 Homepage: https://www.deepin.org

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/default.mk

%:
	dh $@ --buildsystem=cmake

EXTRA_OPTION = -DCMAKE_BUILD_TYPE=Release -Dlinyaps-box_ENABLE_CPACK=ON -Dlinyaps-box_CPM_LOCAL_PACKAGES_ONLY=ON
override_dh_auto_configure:
	dh_auto_configure --  ${EXTRA_OPTION}  ${DH_AUTO_ARGS}

## linglong-box 2.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 project(
   linyaps-box
-  VERSION 2.0.3
+  VERSION 2.1.0
   DESCRIPTION "A simple OCI runtime for desktop applications"
   HOMEPAGE_URL "https://github.com/OpenAtom-Linyaps/linyaps-box"
   LANGUAGES CXX)
@@ -118,7 +118,7 @@
     src/linyaps_box/app.cpp
     src/linyaps_box/app.h
     src/linyaps_box/cgroup.h
-    src/linyaps_box/cgroup_manager.c
+    src/linyaps_box/cgroup_manager.cpp
     src/linyaps_box/cgroup_manager.h
     src/linyaps_box/command/exec.cpp
     src/linyaps_box/command/exec.h
@@ -195,8 +195,7 @@
     COMMAND git rev-parse --short=7 HEAD
     WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
     OUTPUT_VARIABLE GIT_COMMIT_HASH
-    OUTPUT_STRIP_TRAILING_WHITESPACE
-  )
+    OUTPUT_STRIP_TRAILING_WHITESPACE)
 
   set(LINYAPS_BOX_VERSION "${LINYAPS_BOX_VERSION}-dev-${GIT_COMMIT_HASH}")
 endif()
@@ -238,7 +237,7 @@
     OPTIONS "JSON_BuildTests OFF")
   CPMFindPackage(
     NAME CLI11
-    VERSION 2.4.1
+    VERSION 2.5.0
     GITHUB_REPOSITORY CLIUtils/CLI11
     GIT_TAG v2.5.0
     EXCLUDE_FROM_ALL ON
@@ -257,18 +256,18 @@
 list(APPEND linyaps-box_LIBRARY_LINK_LIBRARIES PUBLIC
      nlohmann_json::nlohmann_json)
 
-find_package(CLI11 2.4.1 QUIET)
+find_package(CLI11 2.5.0 QUIET)
 if(NOT CLI11_FOUND)
   add_subdirectory(external/CLI11)
   list(APPEND CMAKE_MODULE_PATH
        "${CMAKE_CURRENT_SOURCE_DIR}/cmake.external/CLI11")
-  find_package(CLI11 2.4.1 REQUIRED)
+  find_package(CLI11 2.5.0 REQUIRED)
   message(STATUS "use vendor CLI11 ${CLI11_VERSION}")
 endif()
 
 list(APPEND linyaps-box_LIBRARY_LINK_LIBRARIES PUBLIC CLI11::CLI11)
 
-add_library("${linyaps-box_LIBRARY}" ${linyaps-box_LIBRARY_SOURCE})
+add_library("${linyaps-box_LIBRARY}" STATIC ${linyaps-box_LIBRARY_SOURCE})
 target_include_directories("${linyaps-box_LIBRARY}"
                            ${linyaps-box_LIBRARY_INCLUDE_DIRS})
 target_link_libraries("${linyaps-box_LIBRARY}"

## linglong-box 2.1.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -91,7 +91,7 @@
 )
 
 set(linyaps-box_ENABLE_CPM
-    ON
+    OFF
     CACHE BOOL "enable CPM")
 
 if(CMAKE_VERSION VERSION_LESS "3.14")
@@ -104,11 +104,6 @@
 set(linyaps-box_CPM_LOCAL_PACKAGES_ONLY
     OFF
     CACHE BOOL "use local packages only")
-
-if(linyaps-box_CPM_LOCAL_PACKAGES_ONLY)
-  message(STATUS "CPM is disabled")
-  set(linyaps-box_ENABLE_CPM OFF)
-endif()
 
 # ==============================================================================
 
@@ -228,6 +223,10 @@
   list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
   include(CPM)
 
+  if (linyaps-box_CPM_LOCAL_PACKAGES_ONLY)
+    set(CPM_USE_LOCAL_PACKAGES ON)
+  endif()
+
   CPMFindPackage(
     NAME nlohmann_json
     VERSION 3.11.3

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/default.mk

%:
	dh $@ --buildsystem=cmake

EXTRA_OPTION = -DCMAKE_BUILD_TYPE=Release -Dlinyaps-box_ENABLE_CPACK=ON -Dlinyaps-box_CPM_LOCAL_PACKAGES_ONLY=ON -Dlinyaps-box_MAKE_RELEASE=ON
override_dh_auto_configure:
	dh_auto_configure --  ${EXTRA_OPTION}  ${DH_AUTO_ARGS}

## linglong-box 2.1.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 project(
   linyaps-box
-  VERSION 2.1.0
+  VERSION 2.1.3
   DESCRIPTION "A simple OCI runtime for desktop applications"
   HOMEPAGE_URL "https://github.com/OpenAtom-Linyaps/linyaps-box"
   LANGUAGES CXX)
@@ -94,6 +94,12 @@
     OFF
     CACHE BOOL "enable CPM")
 
+set(linyaps-box_HARDENING
+    ON
+    CACHE BOOL "enable hardening")
+
+set(CMAKE_POSITION_INDEPENDENT_CODE ON)
+
 if(CMAKE_VERSION VERSION_LESS "3.14")
   set(linyaps-box_ENABLE_CPM OFF)
   message(
@@ -106,6 +112,17 @@
     CACHE BOOL "use local packages only")
 
 # ==============================================================================
+
+if (linyaps-box_HARDENING)
+  message(STATUS "applying harden settings")
+  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pie -Wl,-z,relro -Wl,-z,now")
+  add_compile_options(-fstack-protector-strong)
+
+  if(NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
+    message(STATUS "Non-Debug build, enabling FORTIFY_SOURCE")
+    add_compile_definitions(_FORTIFY_SOURCE=2)
+  endif()
+endif()
 
 set(linyaps-box_LIBRARY linyaps-box)
 set(linyaps-box_LIBRARY_SOURCE
@@ -238,11 +255,12 @@
     NAME CLI11
     VERSION 2.5.0
     GITHUB_REPOSITORY CLIUtils/CLI11
-    GIT_TAG v2.5.0
+    GIT_TAG v2.6.1
     EXCLUDE_FROM_ALL ON
     OPTIONS "CLI11_BUILD_TESTS OFF")
 endif()
 
+# find minimal version
 find_package(nlohmann_json 3.11.3 QUIET)
 if(NOT nlohmann_json_FOUND)
   add_subdirectory(external/nlohmann_json)
@@ -333,12 +351,3 @@
 
 add_executable("${linyaps-box_APP}" ${linyaps-box_APP_SOURCE})
 target_include_directories("${linyaps-box_APP}"
-                           ${linyaps-box_APP_SOURCE_INCLUDE_DIRS})
-target_link_libraries("${linyaps-box_APP}" ${linyaps-box_APP_LINK_LIBRARIES})
-if(linyaps-box_STATIC)
-  target_link_options("${linyaps-box_APP}" PRIVATE -static -static-libgcc
-                      -static-libstdc++)
-endif()
-target_compile_features("${linyaps-box_APP}" PRIVATE cxx_std_17)
-set_property(TARGET "${linyaps-box_APP}" PROPERTY CXX_STANDARD 17)
-set_property(TARGET "${linyaps-box_APP}" PROPERTY CXX_EXTENSIONS OFF)
